; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - Extra.pb
; Version du fichier : 0.8.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : Guimauve
; Courriel : gsaumure@cgocable.ca
; Date : 15-02-2015
; Mise  jour : 22-07-2018
; Code PureBasic : V5.70 Beta 1
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

Procedure MethodsGadgetTextStringGroup(PosX.l, PosY.l, FrameID.l, LastTextID.l, FrameWidth.l = 240)
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows
      
      FrameHeight = 25 + (((LastTextID+1) - FrameID) >> 1) * 30
      
      FrameGadget(FrameID, PosX, PosY, FrameWidth, FrameHeight, "")
      PosY + 25
      FirstTextID = FrameID + 1
      
      For TextID = FirstTextID To LastTextID Step 2
        
        TextGadget(TextID, PosX + 5, PosY, 75, 25, "")
        StringGadget(TextID+1, PosX + 80, PosY, FrameWidth - 85, 25, "")
        
        PosY + 30
        
      Next
      
    CompilerCase #PB_OS_Linux
      
      FrameHeight = 30 + (((LastTextID+1) - FrameID) >> 1) * 35
      
      FrameGadget(FrameID, PosX, PosY, FrameWidth, FrameHeight, "")
      PosY + 25
      FirstTextID = FrameID + 1
      
      For TextID = FirstTextID To LastTextID Step 2
        
        TextGadget(TextID, PosX + 5, PosY, 75, 30, "")
        StringGadget(TextID+1, PosX + 80, PosY, FrameWidth - 85, 30, "")
        
        PosY + 35
        
      Next
      
    CompilerCase #PB_OS_MacOS ; Maybe the interface need some adjustment 
      
      FrameHeight = 30 + (((LastTextID+1) - FrameID) >> 1) * 35
      
      FrameGadget(FrameID, PosX, PosY, FrameWidth, FrameHeight, "")
      PosY + 25
      FirstTextID = FrameID + 1
      
      For TextID = FirstTextID To LastTextID Step 2
        
        TextGadget(TextID, PosX + 5, PosY, 75, 30, "")
        StringGadget(TextID+1, PosX + 80, PosY, FrameWidth - 85, 30, "")
        
        PosY + 35
        
      Next
      
  CompilerEndSelect
  
EndProcedure

Procedure MethodGadgetFollowCheckBox()
  
  GadgetID = EventGadget()
  
  DisableGadget(GadgetID + 1, GetGadgetState(GadgetID) ! 1)
  DisableGadget(GadgetID + 2, GetGadgetState(GadgetID) ! 1)
  
EndProcedure

Procedure MethodGadgets(GadgetID, x, y)
  
  CheckBoxGadget(GadgetID, x, y, 200, 25,"")
  OptionGadget(GadgetID + 1, GadgetLocate::RightOf(GadgetID, 5), y, 90, 25, "")
  OptionGadget(GadgetID + 2, GadgetLocate::RightOf(GadgetID + 1, 5), y, 90, 25, "")
  BindGadgetEvent(GadgetID, @MethodGadgetFollowCheckBox())  
  DisableGadget(GadgetID + 1, 1)
  DisableGadget(GadgetID + 2, 1)
  
EndProcedure

Procedure TextFollowTrackBar()

  SetGadgetText(#Text_Tabulation_Size, Str(GetGadgetState(#TrackBar_Tabulation_Size)))

EndProcedure

Procedure TrackBarGadgetGroup(TrackBarID, TextID, PosX, PosY, FrameWidth)
  
  TrackBarGadget(TrackBarID, PosX , PosY, FrameWidth - 40, 30, 0, 0, #PB_TrackBar_Ticks)
  TextGadget(TextID, GadgetLocate::RightOf(TrackBarID, 5), PosY + 5, 30, 30, "", #PB_Text_Center)
  BindGadgetEvent(TrackBarID, @TextFollowTrackBar()) 
  
EndProcedure 

Procedure TrackBarFollowOption()
  
  GadgetID = EventGadget()
    
  Select GadgetID
      
    Case #Option_Use_NBSPACE_Tabulation
      DisableGadget(#TrackBar_Tabulation_Size, 0)
      DisableGadget(#Text_Tabulation_Size, 0)
      
    Case #Option_Use_ASCII_Tabulation
      DisableGadget(#TrackBar_Tabulation_Size, 1)
      DisableGadget(#Text_Tabulation_Size, 1)
      
  EndSelect
   
EndProcedure

Procedure BrowsePathGadgetGroup(FrameID, PosX, PosY, Width, FrameHeight = 65)
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows
      Height = 25
      
    CompilerCase #PB_OS_Linux
      Height = 34
      
    CompilerCase #PB_OS_MacOS ; Maybe the interface need some adjustment 
      Height = 34
      
  CompilerEndSelect
  
  FrameGadget(FrameID, PosX, PosY, Width, FrameHeight, "")
  
  StringGadget(FrameID + 1, PosX + 5, PosY + 25, Width - 115, Height, "", #PB_String_ReadOnly)
  ButtonGadget(FrameID + 2, GadgetLocate::RightOf(FrameID + 1, 5), PosY + 25, 100, Height, "")
  
EndProcedure

Procedure DateFormatGadgetGroup(FrameID.l, PosX.l, PosY.l, Width.l, FrameHeight.l = 65)
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows
      Height = 25
      
    CompilerCase #PB_OS_Linux
      Height = 34
      
    CompilerCase #PB_OS_MacOS; Maybe the interface need some adjustment 
      Height = 34
      
  CompilerEndSelect
  
  FrameGadget(FrameID, PosX, PosY, Width, FrameHeight, "")
  ComboBoxGadget(FrameID + 1, PosX + 5, PosY + 25, Width - 120, Height)
  ButtonGadget(FrameID + 2, GadgetLocate::RightOf(FrameID + 1, 5), PosY + 25, 50, Height, "-")
  ButtonGadget(FrameID + 3, GadgetLocate::RightOf(FrameID + 2, 5), PosY + 25, 50, Height, "+")
  
EndProcedure

Procedure ExternalModuleGadgetGroup(ComboBoxID.l, PosX.l, PosY.l, Width.l)
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows
      Height = 25
      
    CompilerCase #PB_OS_Linux
      Height = 34
            
    CompilerCase #PB_OS_MacOS ; Maybe the interface need some adjustment 
      Height = 34
      
  CompilerEndSelect
  
  ComboBoxGadget(ComboBoxID, PosX + 5, PosY, Width - 90, Height)
  ButtonGadget(ComboBoxID + 1, GadgetLocate::RightOf(ComboBoxID, 5), PosY, 50, Height, "-")
  ButtonGadget(ComboBoxID + 2, GadgetLocate::RightOf(ComboBoxID + 1, 5), PosY, 50, Height, "+")
  
EndProcedure

Procedure MethodGadgetsStatus(Status.b, CheckBoxGadget)
  
  If Status = 2
    SetGadgetState(CheckBoxGadget, 1)
    SetGadgetState(CheckBoxGadget + 2, 1)
    DisableGadget(CheckBoxGadget + 1, 0)
    DisableGadget(CheckBoxGadget + 2, 0)
  ElseIf Status = 1
    SetGadgetState(CheckBoxGadget, 1)
    SetGadgetState(CheckBoxGadget + 1, 1)
    DisableGadget(CheckBoxGadget + 1, 0)
    DisableGadget(CheckBoxGadget + 2, 0)
  Else
    SetGadgetState(CheckBoxGadget, 0)
    SetGadgetState(CheckBoxGadget + 1, 1)
    DisableGadget(CheckBoxGadget + 1, 1)
    DisableGadget(CheckBoxGadget + 2, 1)
  EndIf
  
EndProcedure

Procedure SelectComboBoxGadgetItem(ComboBoxGadget, ItemText.s)
  
  FoundAtItemID = -1
  
  ItemMax = CountGadgetItems(ComboBoxGadget) - 1
  
  For ItemID = 0 To ItemMax
    
    If GetGadgetItemText(ComboBoxGadget, ItemID) = ItemText
      SetGadgetState(ComboBoxGadget, ItemID)
      FoundAtItemID = ItemID
      Break
    EndIf
    
  Next
  
  If FoundAtItemID = -1
    SetGadgetState(ComboBoxGadget, 0)
  EndIf
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = CU6
; EnableXP
; CompileSourceDirectory