; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - Field.pb
; Version du fichier : 0.9.2
; Programmation : En cours
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 03-10-2014
; Mise  jour : 14-07-2018
; Code PureBasic : V5.70
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Field
  
  Declare New(P_Target.b, P_FieldID.l, P_Description.s)
  Declare GenerateParamList()
  Declare.l SearchInternalStruct(P_Name.s) 
  Declare AddInternalStruct(P_Name.s)
  Declare AddInternalStructField(P_Name.s, P_FieldDefinition.s)
  Declare.s GenerateEnumeration()
  Declare.s GenerateStructures(CallFrom.b)
  Declare.s GenerateStaticArraySizeConstants()
  Declare.s MethodsSpecial(P_Mode.b)
 
  Declare.l CountStructure()
  Declare.l CountInstances(Flag.b = 0)
  
  Declare GadgetLinking(GadgetID, Flag)
  
  Declare FileModule_To_GUI()
  Declare To_GUI(Mode.b = 0)
  Declare From_GUI(Mode.b = 0)
  Declare AddFileModule(Flag.b)
  Declare RemoveFileModule(Flag.b)
  
  Declare.s CurrentFileModuleName(Flag.b, Input.s = "")
  
  Declare SaveProjectFile()
  Declare LoadProjectFile()
  
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  
  Declare GetSpecialMethods()
  
  Declare.b IsSquareMatrix()
  Declare.b IsMatrix()
  Declare.b GetMatrixSizeI()
  Declare.b GetMatrixSizeJ()

  Declare.b IsStaticArrayPresent()
  Declare.b IsDatabaseHelperNeeded(Flag.b = -1)
  Declare.s GenerateMultipleInstanceHelper(P_Mode.b)
  
  Declare Reset(Style.b)
  
  Declare.s GetModuleName()
  Declare SetModuleName(P_ModuleName.s)
  
  Declare.b GetInstanceStyle()
  Declare SetInstanceStyle(P_InstanceStyle.b)
  
  Declare.s GetInstanceID()
  
  Declare.b GetSecondaryInstance()
  Declare SetSecondaryInstance(P_SecondaryInstance.b)
  
  Declare FirstInstance(Target.b)
  Declare NextInstance(Target.b)
  Declare InstanceIndex(Target.b)
  Declare InstanceSize(Target.b)
  Declare FirstSubField(Target.b)
  Declare NextSubField(Target.b)
  Declare SubFieldIndex(Target.b)
  Declare SubFieldSize(Target.b)
  
  Declare FirstInternalStruct()
  Declare NextInternalStruct()
  Declare FirstInternalStructFields()
  Declare NextInternalStructFields()
  Declare InternalStructFieldsIndex()
  Declare InternalStructFieldsSize()
  Declare.s GetInternalStructFields()
  
  Declare.s GetFieldDescription(Target.b)
  Declare.s GetFieldName(Target.b) 
  Declare.b GetFieldType(Target.b)
  Declare.b GetFieldStyle(Target.b)
  Declare.s GetFieldExtensionShort(Target.b)
  Declare.s GetFieldExtensionLong(Target.b)
  Declare.b GetFieldDynamicArrayDimensionCount(Target.b)
  Declare.s GetFieldDynamicArrayDimensionIndexName(Target.b, P_Index.b)
  Declare.s GetFieldExternModuleName(Target.b)
  Declare.s GetFieldExternModuleStructure(Target.b)
  Declare.s GetFieldAccess(Target.b)
  Declare.s GetFieldAccessEmpty(Target.b)
  Declare.s GetFieldAccessMax(Target.b)
  Declare.s GetFieldArrayIndexName(Target.b)
  Declare.s GetFieldArraySizeLoop(Target.b)
  
  Declare.b GetSubFieldType(Target.b)
  Declare.b GetSubFieldStyle(Target.b)
  Declare.s GetSubFieldAccess(Target.b)
  Declare.s GetSubFieldAccessEmpty(Target.b)
  Declare.s GetSubFieldAccessMax(Target.b)
  Declare.s GetSubFieldName(Target.b)
  Declare.b GetSubFieldDynamicArrayDimensionCount(Target.b)
  Declare.s GetSubFieldDynamicArrayDimensionIndexName(Target.b, P_Index.b)
  Declare.s GetSubFieldExternModuleName(Target.b)
  Declare.s GetSubFieldExternModuleStructure(Target.b)
  Declare.s GetSubFieldArrayIndexName(Target.b)
  Declare.s GetSubFieldArraySizeLoop(Target.b)
  Declare.s GetSubFieldExtensionLong(Target.b)
  
  Declare.s GetDynamicArrayOpeningLoop(Target.b, *Ptr_TabSize, SubTarget.b)
  Declare.s GetDynamicArrayClosingLoop(Target.b, *Ptr_TabSize, SubTarget.b)
  
  Declare.s InsertQuickSort(TabSize.b, Test01.s, Test02.s, InstructionMin.s, InstructionMax.s)
  Declare.s InsertLinearSearch(TabSize.b, ArraySizeLoop.s, Test01.s, IndexName.s = "Index")
  Declare.s InsertBinarySearch(TabSize.b, Instruction.s, Test01.s, Test02.s)
  
  
  Declare.s GetStructName()
  Declare.s GetUpdateInitParam()
  Declare.s GetInstanceParam()
  Declare.s GetExtraParam()
  Declare.s GetInstanceAccessPath() 
  
  Declare.b IsLinkedListPresent()
  Declare.b IsDynamicArrayPresent()
  Declare.s FormatEncodedFileModule(Flag.b = 0)
  Declare.s FormatCryptedFileModule(Flag.b = 0)
  
  Enumeration

    #INSTANCE_STYLE_UNIQUE
    #INSTANCE_STYLE_MULTIPLE_ID
    #INSTANCE_STYLE_MULTIPLE_INDEX
    #INSTANCE_STYLE_MULTIPLE_NAME
    #INSTANCE_STYLE_OFF_MODULE
    
    #METHOD_MODE_DECLARE
    #METHOD_MODE_PROCEDURE
    
    #RESET_STYLE_TERMINAL
    #RESET_STYLE_NEW_MODULE
    #RESET_STYLE_AFTER_RUN
    #RESET_STYLE_FLUSH_INTERNAL_STRUCTURE
 
  EndEnumeration
  
    Enumeration 
    
    ;#FIELD_STYLE_DATA
    ;#FIELD_STYLE_POINTER
    
    #FIELD_STYLE_ARRAY
    #FIELD_STYLE_LIST
    #FIELD_STYLE_MAP
    #FIELD_STYLE_BASIC
    #FIELD_STYLE_BASIC_ARRAY
    
  EndEnumeration 
  
  Enumeration 
    
    ;#FIELD_TYPE_DATA
    ;#FIELD_TYPE_POINTER
    
    #FIELD_TYPE_BYTE
    #FIELD_TYPE_ASCII
    #FIELD_TYPE_UNICODE
    #FIELD_TYPE_CHARACTER
    #FIELD_TYPE_INTEGER
    #FIELD_TYPE_WORD
    #FIELD_TYPE_LONG
    #FIELD_TYPE_QUAD
    #FIELD_TYPE_FLOAT
    #FIELD_TYPE_DOUBLE
    #FIELD_TYPE_STRING01
    #FIELD_TYPE_STRING02
    #FIELD_TYPE_MODULE
    #FIELD_TYPE_STRUCTURE
    
  EndEnumeration 
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows 
      #LineFeed = #CRLF$    
      #TwinLineFeed = #CRLF$ + #CRLF$
      
    CompilerCase #PB_OS_Linux
      #LineFeed = #LF$
      #TwinLineFeed = #LF$ + #LF$
      
    CompilerCase #PB_OS_MacOS
      #LineFeed = #CR$
      #TwinLineFeed = #CR$ + #CR$
      
  CompilerEndSelect
  
  #EmptyString = Chr(34) + Chr(34)
  
EndDeclareModule

Module Field
   
  #CAME_FROM_PRIMARY = 0
  #CAME_FROM_SECONDARY = 1

  Enumeration
    
    #INSTRUCTION_MODE_RESET
    #INSTRUCTION_MODE_UPDATE
    
    #INSTRUCTION_MODE_READ_PREF
    #INSTRUCTION_MODE_WRITE_PREF
    
    #INSTRUCTION_MODE_READ_BINARY
    #INSTRUCTION_MODE_WRITE_BINARY
    
    #INSTRUCTION_MODE_READ_ENCODED
    #INSTRUCTION_MODE_WRITE_ENCODED
    
    #INSTRUCTION_MODE_READ_CRYPTED
    #INSTRUCTION_MODE_WRITE_CRYPTED
    
    #INSTRUCTION_MODE_XML_SET_NODE
    #INSTRUCTION_MODE_XML_GET_NODE
    
    #INSTRUCTION_MODE_XML_SET_ATTRIB
    #INSTRUCTION_MODE_XML_GET_ATTRIB
    
    #INSTRUCTION_MODE_ZERO
    #INSTRUCTION_MODE_ONE
    
    #INSTRUCTION_MODE_QUICK_SORT_ASCENDING
    #INSTRUCTION_MODE_QUICK_SORT_DESCENDING
    #INSTRUCTION_MODE_LINEAR_SEARCH
    #INSTRUCTION_MODE_BINARY_SEARCH
    #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE
    
  EndEnumeration
  
  Structure FileModule
    
    Name.s
    DisplayName.s
    FileName.s
    Prefix.s
    
  EndStructure 
  
  Structure Struct
    
    Name.s
    List Fields.s()
    
  EndStructure
  
  Structure General
    
    UpdateInitParam.s
    ModuleName.s
    InstanceID.s
    SpecialMethods.b
    GenerateEnumConstants.b
    SizeConstants.b
    
    StaticArray.b
    StaticArrayFieldName.b
    InstanceStyle.b
    IsMatrix.b
    IsSquareMatrix.b  
    MatrixSizeI.b
    MatrixSizeJ.b
    IsDatabaseHelperNeeded.b
    
    IsLinkedListPresent.b
    IsDynamicArrayPresent.b
    IsStaticArrayPresent.b

    EncodedModuleGadget.l
    CryptedModuleGadget.l
    InternalStructListViewGadget.l
    InternalStructEditorGadget.l
    
    SecondaryInstance.b
    
    List EncodedModule.FileModule()
    List CryptedModule.FileModule()
    List Struct.Struct()
    
  EndStructure
  
  Structure Field
    
    Description.s
    Name.s
    Access.s
    AccessEmpty.s
    AccessMax.s
    Type.b
    Style.b
    ExtensionShort.s
    ExtensionLong.s
    ExtraInfo.s
    FixedString.s
    ArraySize.l
    ArraySizeCte.s
    ArraySizeLoop.s
    ArraySizeDeclare.s
    ArrayIndexName.s
    DynamicArrayDimensionCount.b
    DynamicArrayDimensionDeclare.s
    DynamicArrayDimensionIndexName.s[10]
    DynamicArrayDimensionIndexMaxName.s[10]
    ExternModuleName.s
    ExternModuleStructure.s
    IsSubField.b
    
  EndStructure
  
  Structure Instance
    
    ID.l
    Field.Field
    List SubField.Field()
    
  EndStructure 
  
  Global General.General
  Global NewList Primary.Instance()
  Global NewList Secondary.Instance()
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Procdures prives <<<<<
  
  Procedure.l SearchInstances(P_InstanceID.l, Target.b = 0)
    
    Protected IsFoundAtIndex.l = -1
    
    If Target = 0 
      
      ForEach Primary()
        
        If Primary()\ID = P_InstanceID
          IsFoundAtIndex = ListIndex(Primary())
          Break
        EndIf
        
      Next
      
    ElseIf Target = 1
      
      ForEach Secondary()
        
        If Secondary()\ID = P_InstanceID
          IsFoundAtIndex = ListIndex(Secondary())
          Break
        EndIf
        
      Next
      
    EndIf
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure.l SearchInternalStruct(P_Name.s)
    
    Protected IsFoundAtIndex.l = -1
    
    ForEach General\Struct()
      
      If General\Struct()\Name = P_Name
        IsFoundAtIndex = ListIndex(General\Struct())
        Break
      EndIf
      
    Next
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure.l SearchStructField(P_Name.s, P_FieldDefinition.s)
    
    Protected IsFoundAtIndex.l = -1
    
    If SearchInternalStruct(P_Name)
      
      ForEach General\Struct()\Fields()
        
        If General\Struct()\Fields() = P_FieldDefinition
          IsFoundAtIndex = ListIndex(General\Struct()\Fields())
          Break
        EndIf
        
      Next
      
    EndIf
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Oprateur ExtractBracket <<<<<
  
  Procedure.s ExtractBracket(P_Description.s, OpenBracket.s, CloseBracket.s, Flag.b = 0)
    
    If FindString(P_Description, OpenBracket, 1)
      
      BracketPart.s = StringBetween::FindIt(P_Description, OpenBracket, CloseBracket)
      
      If Flag = 0
        BracketPart = OpenBracket + BracketPart + CloseBracket
      EndIf
      
    EndIf
    
    ProcedureReturn BracketPart
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Commandes pour les tableaux Dynamiques <<<<<
  
  Procedure DynamicArrayDimensionsExtraction(*FieldA.Field, ArrayDefinition.s)
    
    DimensionPart.s = ExtractBracket(ArrayDefinition, "(", ")", 1)
    
    *FieldA\DynamicArrayDimensionDeclare = "(" + DimensionPart + ")"
    *FieldA\DynamicArrayDimensionCount = CountString(DimensionPart, ",") + 1
    
    For Index = *FieldA\DynamicArrayDimensionCount To 1 Step -1  
      *FieldA\DynamicArrayDimensionIndexName[Index-1] = *FieldA\Name + "_ID_" + Str(Index)
    Next
    
    For Index = 1 To *FieldA\DynamicArrayDimensionCount
      *FieldA\DynamicArrayDimensionIndexMaxName[Index-1] = *FieldA\Name + "_Max_" + Str(Index) + "D"
    Next
    
  EndProcedure
  
  Procedure.s BuiltDynamicArrayIndexList(*FieldA.Field, Mode.b)
    
    If *FieldA\DynamicArrayDimensionCount <> 0
      
      Select Mode
          
        Case 0, 1, 2
          
          For Index = 0 To *FieldA\DynamicArrayDimensionCount - 1
            ParamList.s = ParamList + ", " + *FieldA\DynamicArrayDimensionIndexName[Index]          
          Next 
          
          If Mode = 1 Or Mode = 2
            ParamList = Right(ParamList, Len(ParamList) - 2)       
          EndIf 
          
          If Mode = 2
            ParamList = "(" + ParamList + ")"
          EndIf
          
          ;     Case 2
          ;       
          ;       For Index = 0 To GetFieldDynamicArrayDimensionCount(*FieldA) - 1
          ;         ParamList = ParamList + ", 0"         
          ;       Next 
          
        Case 3
          
          For Index = 1 To *FieldA\DynamicArrayDimensionCount
            
            ParamList = ParamList + *FieldA\Name + "_Max_" + Str(Index) + "D"
            
            If Index < *FieldA\DynamicArrayDimensionCount
              ParamList + ", "
            EndIf
            
          Next
          
          ;     Case 4
          ;       
          ;       For Index = 1 To *FieldA\DynamicArrayDimensionCount
          ;         ParamList = ParamList + ", " + DynamicArraySize(*FieldA, #VARIABLE_NAME_A, Str(Index))
          ;       Next
          ;       
          ;     Case 5
          ;       
          ;       For Index = 1 To *FieldA\DynamicArrayDimensionCount
          ;         ParamList = ParamList + ", " + DynamicArraySize(*FieldA, #POINTER_NAME_A, Str(Index))
          ;       Next
          
        Case 6
          
          For Index = 1 To *FieldA\DynamicArrayDimensionCount
            
            ParamList = ParamList + " + Str(" + *FieldA\DynamicArrayDimensionIndexName[Index-1]  + ")"
            
            If Index < *FieldA\DynamicArrayDimensionCount
              ParamList = ParamList + " + " + Chr(34) + "_" + Chr(34)
            EndIf 
            
          Next 
          
      EndSelect
      
    EndIf
    
    ProcedureReturn ParamList
  EndProcedure 
  
  Procedure.s DynamicArraySize(*FieldA.Field, Dimension.s = "DimensionID", P_InstanceCameFrom.b = #CAME_FROM_PRIMARY, *ParentField.Field = #Null)
    
    If *FieldA\Type = #FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf
    
    If *ParentField <> #Null
      
      Select *ParentField\Style
          
        Case #FIELD_STYLE_ARRAY
          Parent.s = *ParentField\Name + "(" + BuiltDynamicArrayIndexList(*ParentField, 1) + ")\"
          
        Case #FIELD_STYLE_LIST
          Parent.s = *ParentField\Name + "()\"
          
        Case #FIELD_STYLE_MAP
          Parent.s = *ParentField\Name + "()\"
          
        Case #FIELD_STYLE_BASIC
          Parent.s = *ParentField\Name + "\"
          
        Case #FIELD_STYLE_BASIC_ARRAY
          Parent.s = *ParentField\Name + "[" + *ParentField\ArrayIndexName + "]\"
          
      EndSelect
      
    EndIf
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        Output.s = "ArraySize(Instance\" + Parent + *FieldA\Name + DollarSign + "(), " + Dimension + ")"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        Output.s = "ArraySize(Instances()\" + Parent + *FieldA\Name + DollarSign + "(), " + Dimension + ")"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        Output.s = "ArraySize(*" +  General\ModuleName + "A\" + Parent + *FieldA\Name + DollarSign + "(), " + Dimension + ")"
        
    EndSelect
    
    If General\SecondaryInstance = #True And P_InstanceCameFrom = #CAME_FROM_SECONDARY
      Output.s = "ArraySize(Secondary\" + *FieldA\Name + DollarSign + "(), " + Dimension + ")"
    EndIf
    
    ProcedureReturn Output
  EndProcedure
 
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Commandes pour les Structures Internes <<<<<
  
  Procedure AddInternalStruct(P_Name.s)
    
    If SearchInternalStruct(P_Name) = -1
      AddElement(General\Struct())
      General\Struct()\Name = P_Name
    EndIf
    
  EndProcedure
  
  Procedure AddInternalStructField(P_Name.s, P_FieldDefinition.s)
    
    If SearchStructField(P_Name, P_FieldDefinition) = -1
      AddElement(General\Struct()\Fields())
      General\Struct()\Fields() = P_FieldDefinition
    EndIf
    
  EndProcedure
  
  Procedure.s GenerateInternalStruct(TabSize.b)
    
    ForEach General\Struct()
      
      Buffer.s + Comments::Tabulation(TabSize) + "Structure " + General\Struct()\Name + #TwinLineFeed
      
      ForEach General\Struct()\Fields()
        Buffer + Comments::Tabulation(TabSize+1) + General\Struct()\Fields() + #LineFeed
      Next
      
      Buffer + #LineFeed + Comments::Tabulation(TabSize) + "EndStructure" + #TwinLineFeed
      
    Next
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Extraire l'information d'un champs (Module ou structure interne) <<<<<
  
  Procedure.s FieldFromDescription(*FieldA.Field, P_Description.s)
    
    *FieldA\Description = P_Description
    
    If FindString(*FieldA\Description, ";", 1)
      
      ExtraPart01.s = Trim(StringField(*FieldA\Description, 1, ";"))
      ExtraPart02.s = Trim(StringField(*FieldA\Description, 2, ";"))
      *FieldA\ExtraInfo = " ; " + ExtraPart02
      *FieldA\Description = ExtraPart01 + *FieldA\ExtraInfo
      
      If General\SpecialMethods = #False
        If FindString(ExtraPart02, "Special", 1)
          General\SpecialMethods = #True
        EndIf
      EndIf
      
      If General\GenerateEnumConstants = #False
        If FindString(ExtraPart02, "Enum", 1)
          General\GenerateEnumConstants = #True
        EndIf
      EndIf
      
    EndIf
    
    FirstPart.s = StringField(*FieldA\Description, 1, " ")
    SecondPart.s = StringField(*FieldA\Description, 2, " ")
    
    Select UCase(FirstPart)
        
      Case "ARRAY"
        
        General\IsDynamicArrayPresent = #True
        *FieldA\Style = #FIELD_STYLE_ARRAY

        If FindString(SecondPart, "$", 1)
          *FieldA\Name = StringField(StringField(SecondPart, 1, "$"), 1, "(")
          *FieldA\ExtensionShort = "$"
          DynamicArrayDimensionsExtraction(*FieldA, *FieldA\Description)
          *FieldA\Access = *FieldA\Name + "$(" + BuiltDynamicArrayIndexList(*FieldA, 1) + ")"
          *FieldA\AccessEmpty = *FieldA\Name + "$()"
          *FieldA\AccessMax = *FieldA\Name + "$(" + BuiltDynamicArrayIndexList(*FieldA, 3) + ")"
        Else
          *FieldA\Name = StringField(StringField(SecondPart, 1, "."), 1, "(")
          *FieldA\ExtensionShort = StringField(StringField(SecondPart, 2, "."), 1, "(")
          DynamicArrayDimensionsExtraction(*FieldA, *FieldA\Description)
          *FieldA\Access = *FieldA\Name + "(" + BuiltDynamicArrayIndexList(*FieldA, 1) + ")"
          *FieldA\AccessEmpty = *FieldA\Name + "()"
          *FieldA\AccessMax = *FieldA\Name + "(" + BuiltDynamicArrayIndexList(*FieldA, 3) + ")"
        EndIf  
        
      Case "LIST"
        
        General\IsLinkedListPresent = #True
        *FieldA\Style = #FIELD_STYLE_LIST
        
        If FindString(SecondPart, "$", 1)
          *FieldA\Name = StringField(SecondPart, 1, "$")
          *FieldA\ExtensionShort = "$"
          *FieldA\Access = *FieldA\Name + "$()"
        Else
          *FieldA\Name = StringField(SecondPart, 1, ".")
          *FieldA\ExtensionShort = StringField(StringField(SecondPart, 2, "."), 1, "(")
          *FieldA\Access = *FieldA\Name + "()"
        EndIf
        
      Case "MAP"
        
        *FieldA\Style = #FIELD_STYLE_MAP
        
        If FindString(SecondPart, "$", 1)
          *FieldA\Name = StringField(SecondPart, 1, "$")
          *FieldA\ExtensionShort = "$"
          *FieldA\Access = *FieldA\Name + "$()"
        Else
          *FieldA\Name = StringField(SecondPart, 1, ".")
          *FieldA\ExtensionShort = StringField(StringField(SecondPart, 2, "."), 1, "(")
          *FieldA\Access = *FieldA\Name + "()"
        EndIf
        
      Default
        
        *FieldA\Style = #FIELD_STYLE_BASIC
        
        If FindString(FirstPart, "$", 1)
          *FieldA\Name = StringField(FirstPart, 1, "$")
          *FieldA\ExtensionShort = "$"
          *FieldA\Access = *FieldA\Name + "$"
        Else
          *FieldA\Name = StringField(FirstPart, 1, ".")
          *FieldA\ExtensionShort = StringField(FirstPart, 2, ".")
          *FieldA\Access = *FieldA\Name
        EndIf 
        
    EndSelect 
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    *FieldA\FixedString = ExtractBracket(*FieldA\Description, "{", "}")
    
    If *FieldA\FixedString <> ""
      *FieldA\ExtensionShort = StringField(*FieldA\ExtensionShort, 1, "{")
    EndIf
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    ArrayBracket.s = ExtractBracket(*FieldA\Description, "[", "]")
    
    If ArrayBracket <> ""
      
      *FieldA\Style = #FIELD_STYLE_BASIC_ARRAY
      *FieldA\ArrayIndexName = *FieldA\Name + "ID"
      *FieldA\ExtensionShort = StringField(*FieldA\ExtensionShort, 1, "[") 
      
      If *FieldA\ExtensionShort = "$"
        *FieldA\Access = *FieldA\Name + "$[" + *FieldA\ArrayIndexName + "]"
      Else
        *FieldA\Access = *FieldA\Name + "[" + *FieldA\ArrayIndexName + "]"
      EndIf
      
      If FindString(ArrayBracket, "#",1)
        
        *FieldA\ArraySizeCte = UCase("#" + *FieldA\Name + "_max")
        *FieldA\ArraySizeLoop = *FieldA\ArraySizeCte + " - 1"
        
        If FindString(ArrayBracket, "=", 1)
          Size.s = Trim(StringField(StringField(ArrayBracket, 2, "="), 1, "]"))
          *FieldA\ArraySizeDeclare = *FieldA\ArraySizeCte + " = " + Size
          *FieldA\ArraySize = Val(Size)
        Else
          *FieldA\ArraySizeDeclare = *FieldA\ArraySizeCte + " = 5"
          *FieldA\ArraySize = 5
        EndIf
        
        If *FieldA\ArraySizeDeclare <> ""
          General\SizeConstants = #True
        EndIf 
        
      Else 
        
        Size.s = ExtractBracket(ArrayBracket, "[", "]", 1)
        *FieldA\ArraySizeCte = Size
        *FieldA\ArraySize = Val(Size)
        *FieldA\ArraySizeLoop = Str(*FieldA\ArraySize - 1)
        
      EndIf
      
      FieldArrayName.s = *FieldA\ExtraInfo
      
      If FieldArrayName <> ""
        FieldArrayName = " ; " + Trim(FieldArrayName)
        General\StaticArrayFieldName = #True
      EndIf
      
      IndexStruct00.s = ", " + *FieldA\ArrayIndexName
      IndexStruct01.s = "[" + *FieldA\ArrayIndexName + "]"
      
    Else
      
      IndexStruct00 = ""
      IndexStruct01 = ""
      
    EndIf

    Select *FieldA\ExtensionShort
        
      Case "$"
        *FieldA\Type = #FIELD_TYPE_STRING01
        *FieldA\ExtensionLong = "$"
        
      Case "s", "S"
        *FieldA\Type = #FIELD_TYPE_STRING02
        *FieldA\ExtensionLong = ".s"
        
      Case "b", "B"
        *FieldA\Type = #FIELD_TYPE_BYTE
        *FieldA\ExtensionLong = ".b"
        
      Case "a", "A"
        *FieldA\Type = #FIELD_TYPE_ASCII
        *FieldA\ExtensionLong = ".a"
        
      Case "u", "U"
        *FieldA\Type = #FIELD_TYPE_UNICODE
        *FieldA\ExtensionLong = ".u"
        
      Case "c", "C"
        *FieldA\Type = #FIELD_TYPE_CHARACTER
        *FieldA\ExtensionLong = ".c"
        
      Case "i", "I"
        *FieldA\Type = #FIELD_TYPE_INTEGER
        *FieldA\ExtensionLong = ".i"
        
      Case "w", "W"
        *FieldA\Type = #FIELD_TYPE_WORD
        *FieldA\ExtensionLong = ".w"
        
      Case "l", "L"
        *FieldA\Type = #FIELD_TYPE_LONG
        *FieldA\ExtensionLong = ".l"
        
      Case "q", "Q"
        *FieldA\Type = #FIELD_TYPE_QUAD
        *FieldA\ExtensionLong = ".q"
        
      Case "f", "F"
        *FieldA\Type = #FIELD_TYPE_FLOAT
        *FieldA\ExtensionLong = ".f"
        
      Case "d", "D"
        *FieldA\Type = #FIELD_TYPE_DOUBLE
        *FieldA\ExtensionLong = ".d"
        
      Default 
        *FieldA\Type = #FIELD_TYPE_STRUCTURE
        *FieldA\ExtensionLong = "." + *FieldA\ExtensionShort
        
    EndSelect 
    
    If *FieldA\Type = #FIELD_TYPE_STRUCTURE
      
      If FindString(*FieldA\ExtensionShort, "::")
        *FieldA\Type = #FIELD_TYPE_MODULE
        *FieldA\ExternModuleName = StringField(*FieldA\ExtensionShort, 1, "::")
        *FieldA\ExternModuleStructure = StringField(*FieldA\ExtensionShort, 2, "::") 
      Else
        ProcedureReturn *FieldA\ExtensionShort
      EndIf
      
    EndIf

    If *FieldA\Style = #FIELD_STYLE_BASIC_ARRAY
      
      If General\IsStaticArrayPresent = #False
        If *FieldA\Type >= #FIELD_TYPE_BYTE And *FieldA\Type <= #FIELD_TYPE_STRING02
          General\IsStaticArrayPresent = #True
        EndIf
      EndIf
      
    EndIf 

  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Gnration de la liste de constante pour le dimensionnement des tableaux statiques <<<<<
  
  Procedure.s GenerateStaticArraySizeConstants()
    
    ForEach Primary()
      
      If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY
        If Primary()\Field\ArraySizeDeclare <> ""
          Buffer.s + Comments::Tabulation(1) + Primary()\Field\ArraySizeDeclare + #Linefeed
        EndIf
      EndIf
      
    Next
    
    ForEach Secondary()
      
      If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY
        If Secondary()\Field\ArraySizeDeclare <> ""
          Buffer + Comments::Tabulation(1) + Secondary()\Field\ArraySizeDeclare + #Linefeed
        EndIf
      EndIf
      
    Next
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Gnration des numrations <<<<<
  
  Procedure.s GenerateEnumeration() 
    
    If General\GenerateEnumConstants = #True
      
      ForEach Primary()
        
        If Primary()\Field\Style = #FIELD_STYLE_BASIC
          
          If FindString(Primary()\Field\Description, "; Enum :")
            
            Enum.s = Trim(StringField(StringField(Primary()\Field\Description, 2, ";"), 2, ":"))
            CteCount = CountString(Enum, ",") + 1
            Output.s + Comments::Tabulation(1) + "Enumeration" + #TwinLineFeed
            
            For Index = 1 To CteCount
              Output + Comments::Tabulation(2) + UCase("#" + Primary()\Field\Name + "_" + Trim(StringField(Enum, Index, ","))) + #LineFeed
            Next
            
            Output + #LineFeed
            Output + Comments::Tabulation(1) + "EndEnumeration" + #LineFeed
            
          EndIf
          
        EndIf
        
      Next
      
      ForEach Secondary()
        
        If Secondary()\Field\Style = #FIELD_STYLE_BASIC
          
          If FindString(Secondary()\Field\Description, "; Enum :")
            
            Enum.s = Trim(StringField(StringField(Secondary()\Field\Description, 2, ";"), 2, ":"))
            CteCount = CountString(Enum, ",") + 1
            
            If Output <> ""
              Output + #LineFeed
            EndIf
            
            Output.s + Comments::Tabulation(1) + "Enumeration" + #TwinLineFeed
            
            For Index = 1 To CteCount
              Output + Comments::Tabulation(2) + UCase("#" + Secondary()\Field\Name + "_" + Trim(StringField(Enum, Index, ","))) + #LineFeed
            Next
            
            Output + #LineFeed
            Output + Comments::Tabulation(1) + "EndEnumeration" + #LineFeed
            
          EndIf
          
        EndIf
        
      Next
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Gnration des mthodes spciales <<<<<
  
  Procedure.s MethodsSpecial(P_Mode.b)
    
    If General\SpecialMethods = #True
      
      ForEach Primary()
        
        Select Primary()\Field\Type
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            ExtraParam.s = ".0"
            
          Default 
            ExtraParam = ""
            
        EndSelect
        
        If Primary()\Field\Style = #FIELD_STYLE_BASIC
          
          If FindString(Primary()\Field\ExtraInfo, "Special")
            
            If FindString(Primary()\Field\ExtraInfo, "Increment")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output.s + Comments::Tabulation(1) + "Declare Increment" + Primary()\Field\Name + "(P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Declare Increment" + Primary()\Field\Name + "(" + General\InstanceID + ", P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
                Case #METHOD_MODE_PROCEDURE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Procedure Increment" + Primary()\Field\Name + "(P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + " = Instance\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID 
                      Output + Comments::Tabulation(1) + "Procedure Increment" + Primary()\Field\Name + "(P_InstanceID.l, P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> - 1" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(1) + "Procedure Increment" + Primary()\Field\Name + "(P_Index.l, P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SelectElement(Instances(), P_Index)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Procedure Increment" + Primary()\Field\Name + "(P_Name.s, P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
              EndSelect
              
            EndIf
            
            If FindString(Primary()\Field\ExtraInfo, "Decrement")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Declare Decrement" + Primary()\Field\Name + "(P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                                           
                    Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Declare Decrement" + Primary()\Field\Name + "(" + General\InstanceID + ", P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
                Case #METHOD_MODE_PROCEDURE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Procedure Decrement" + Primary()\Field\Name + "(P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + " = Instance\" + Primary()\Field\Name + " - P_Decrement" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID 
                      Output + Comments::Tabulation(1) + "Procedure Decrement" + Primary()\Field\Name + "(P_InstanceID.l, P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> - 1" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " - P_Decrement" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(1) + "Procedure Decrement" + Primary()\Field\Name + "(P_Index.l, P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SelectElement(Instances(), P_Index)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " - P_Decrement" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Procedure Decrement" + Primary()\Field\Name + "(P_Name.s, P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " - P_Decrement" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
              EndSelect
              
            EndIf
            
            If FindString(Primary()\Field\ExtraInfo, "Toggle")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Declare Toggle" + Primary()\Field\Name + "()" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Declare Toggle" + Primary()\Field\Name + "(" + General\InstanceID + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect 
                  
                Case #METHOD_MODE_PROCEDURE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Procedure Toggle" + Primary()\Field\Name + "()" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + " = Instance\" + Primary()\Field\Name + " ! 1" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID 
                      Output + Comments::Tabulation(1) + "Procedure Toggle" + Primary()\Field\Name + "(P_InstanceID.l)" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> - 1" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " ! 1" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(1) + "Procedure Toggle" + Primary()\Field\Name + "(P_Index.l)" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SelectElement(Instances(), P_Index)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " ! 1" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Procedure Toggle" + Primary()\Field\Name + "(P_Name.s)" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " ! 1" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
              EndSelect

            EndIf      
            
            If FindString(Primary()\Field\ExtraInfo, "Looping")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Declare Looping" + Primary()\Field\Name + "(P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Declare Looping" + Primary()\Field\Name + "(" + General\InstanceID + ", P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #LineFeed

                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
                Case #METHOD_MODE_PROCEDURE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Procedure Looping" + Primary()\Field\Name + "(P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + " = Instance\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If Instance\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instance\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(2) + "ElseIf Instance\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instance\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID
                      Output + Comments::Tabulation(1) + "Procedure Looping" + Primary()\Field\Name + "(P_InstanceID.l, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> - 1" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(1) + "Procedure Looping" + Primary()\Field\Name + "(P_Index.l, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SelectElement(Instances(), P_Index)" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Procedure Looping" + Primary()\Field\Name + "(P_Name.s, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If FindMapElement(Instances(), P_Name)" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed                     
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect 
                  
              EndSelect
              
            EndIf
            
            If FindString(Primary()\Field\ExtraInfo, "Scrolling")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Declare Scrolling" + Primary()\Field\Name + "(P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Declare Scrolling" + Primary()\Field\Name + "(" + General\InstanceID + ", P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
                Case #METHOD_MODE_PROCEDURE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Procedure Scrolling" + Primary()\Field\Name + "(P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + " = Instance\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If Instance\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instance\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(2) + "ElseIf Instance\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instance\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID
                      Output + Comments::Tabulation(1) + "Procedure Scrolling" + Primary()\Field\Name + "(P_InstanceID.l, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> - 1" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(1) + "Procedure Scrolling" + Primary()\Field\Name + "(P_Index.l, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SelectElement(Instances(), P_Index)" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Procedure Scrolling" + Primary()\Field\Name + "(P_Name.s, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If FindMapElement(Instances(), P_Name)" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed     
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect 
                  
              EndSelect
              
            EndIf
            
          EndIf
          
        EndIf
        
      Next
      
      ForEach Secondary()
        
        If Secondary()\Field\Style = #FIELD_STYLE_BASIC
          
          If FindString(Secondary()\Field\ExtraInfo, "Special")
            
            If FindString(Secondary()\Field\ExtraInfo, "Increment")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  Output.s + Comments::Tabulation(1) + "Declare Increment" + Secondary()\Field\Name + "(P_Increment" + Secondary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                  
                Case #METHOD_MODE_PROCEDURE
                  Output + Comments::Tabulation(1) + "Procedure Increment" + Secondary()\Field\Name + "(P_Increment" + Secondary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "Secondary\" + Secondary()\Field\Name + " = Secondary\" + Secondary()\Field\Name + " + P_Increment" + #TwinLineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
              EndSelect
              
            EndIf
            
            If FindString(Secondary()\Field\ExtraInfo, "Decrement")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  Output.s + Comments::Tabulation(1) + "Declare Decrement" + Secondary()\Field\Name + "(P_Decrement" + Secondary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                  
                Case #METHOD_MODE_PROCEDURE
                  Output + Comments::Tabulation(1) + "Procedure Decrement" + Secondary()\Field\Name + "(P_Decrement" + Secondary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "Secondary\" + Secondary()\Field\Name + " = Secondary\" + Secondary()\Field\Name + " - P_Decrement" + #TwinLineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
              EndSelect
              
            EndIf
            
            If FindString(Secondary()\Field\ExtraInfo, "Toggle")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  Output + Comments::Tabulation(1) + "Declare Toggle" + Secondary()\Field\Name + "()" + #LineFeed
                  
                Case #METHOD_MODE_PROCEDURE
                  Output + Comments::Tabulation(1) + "Procedure Toggle" + Secondary()\Field\Name + "()" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "Secondary\" + Secondary()\Field\Name + " = Secondary\" + Secondary()\Field\Name + " ! 1" + #TwinLineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
              EndSelect
              
            EndIf    
                  
            If FindString(Secondary()\Field\ExtraInfo, "Looping")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  Output + Comments::Tabulation(1) + "Declare Looping" + Secondary()\Field\Name + "(P_Minimum" + Secondary()\Field\ExtensionLong + ", P_Maximum" + Secondary()\Field\ExtensionLong + ", P_Increment" + Secondary()\Field\ExtensionLong + ")" + #LineFeed
                  
                Case #METHOD_MODE_PROCEDURE
                  Output + Comments::Tabulation(1) + "Procedure Looping" + Secondary()\Field\Name + "(P_Minimum" + Secondary()\Field\ExtensionLong + ", P_Maximum" + Secondary()\Field\ExtensionLong + ", P_Increment" + Secondary()\Field\ExtensionLong + ")" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "Secondary\" + Secondary()\Field\Name + " = Secondary\" + Secondary()\Field\Name + " + P_Increment" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "If Secondary\" + Secondary()\Field\Name + " > P_Maximum" + #LineFeed
                  Output + Comments::Tabulation(3) + "Secondary\" + Secondary()\Field\Name + " = P_Minimum" + #LineFeed
                  Output + Comments::Tabulation(2) + "ElseIf Secondary\" + Secondary()\Field\Name + " < P_Minimum" + #LineFeed
                  Output + Comments::Tabulation(3) + "Secondary\" + Secondary()\Field\Name + " = P_Maximum" + #LineFeed
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
              EndSelect
              
            EndIf
            
            If FindString(Secondary()\Field\ExtraInfo, "Scrolling")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  Output + Comments::Tabulation(1) + "Declare Scrolling" + Secondary()\Field\Name + "(P_Minimum" + Secondary()\Field\ExtensionLong + ", P_Maximum" + Secondary()\Field\ExtensionLong + ", P_Increment" + Secondary()\Field\ExtensionLong + ")" + #LineFeed
                  
                Case #METHOD_MODE_PROCEDURE
                  Output + Comments::Tabulation(1) + "Procedure Scrolling" + Secondary()\Field\Name + "(P_Minimum" + Secondary()\Field\ExtensionLong + ", P_Maximum" + Secondary()\Field\ExtensionLong + ", P_Increment" + Secondary()\Field\ExtensionLong + ")" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "Secondary\" + Secondary()\Field\Name + " = Secondary\" + Secondary()\Field\Name + " + P_Increment" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "If Secondary\" + Secondary()\Field\Name + " > P_Maximum" + #LineFeed
                  Output + Comments::Tabulation(3) + "Secondary\" + Secondary()\Field\Name + " = P_Maximum" + #LineFeed
                  Output + Comments::Tabulation(2) + "ElseIf Secondary\" + Secondary()\Field\Name + " < P_Minimum" + #LineFeed
                  Output + Comments::Tabulation(3) + "Secondary\" + Secondary()\Field\Name + " = P_Minimum" + #LineFeed
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
              EndSelect
              
            EndIf
            
          EndIf
          
        EndIf
        
      Next
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
 
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Basic Array Support Instruction <<<<<

  Procedure.s InsertQuickSort(TabSize.b, Test01.s, Test02.s, InstructionMin.s, InstructionMax.s)
    
    Buffer.s = Comments::Tabulation(TabSize) + "Repeat" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "While " + Test01 + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "MinIndex + 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "Wend" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "While " + Test02 + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "MaxIndex - 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "Wend" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "If MinIndex <= MaxIndex" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "Swap " + InstructionMin + ", " + InstructionMax + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "MinIndex + 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "MaxIndex - 1" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "EndIf" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize) + "Until MinIndex > MaxIndex" + #LineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s InsertLinearSearch(TabSize.b, ArraySizeLoop.s, Test01.s, IndexName.s = "Index")
    
    Buffer.s = Comments::Tabulation(TabSize) + ArraySizeLoop + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "If " + Test01 + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "IsFoundAtIndex = " + IndexName + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "Break" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "EndIf" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize) + "Next" + #LineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s InsertBinarySearch(TabSize.b, Instruction.s, Test01.s, Test02.s)
    
    Buffer.s = Comments::Tabulation(TabSize) + "While StartPosition <= EndPosition" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "MiddlePosition = (StartPosition + EndPosition + 1) >> 1" + #LineFeed
    
    If Instruction <> ""
      Buffer + Comments::Tabulation(TabSize + 1) + Instruction + #LineFeed
    EndIf
    
    Buffer + #LineFeed + Comments::Tabulation(TabSize + 1) + "If " + Test01 + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "EndPosition = MiddlePosition - 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "ElseIf " + Test02 + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "StartPosition = MiddlePosition + 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "Else" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "StartPosition = EndPosition + 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "IsFoundAtIndex = MiddlePosition" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "EndIf" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize) + "Wend" + #LineFeed
    
    ProcedureReturn Buffer
  EndProcedure
 
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Procdures publiques <<<<<
 
  Procedure New(P_Target.b, P_FieldID.l, P_Description.s)
    
    If P_Target = 0
      
      If SearchInstances(P_FieldID, 0) = -1
        AddElement(Primary())
      EndIf
      
      Primary()\ID = P_FieldID
      
      StructName.s = FieldFromDescription(Primary()\Field, P_Description)
      
      If StructName <> ""
        
        If SearchInternalStruct(StructName) <> -1
          
          ForEach General\Struct()\Fields()
            AddElement(Primary()\SubField())
            Primary()\SubField()\IsSubField = #True
            FieldFromDescription(Primary()\SubField(), General\Struct()\Fields())
          Next
          
        EndIf
        
      EndIf
      
    ElseIf P_Target = 1
      
      If SearchInstances(P_FieldID, 1) = -1
        AddElement(Secondary())
      EndIf
      
      Secondary()\ID = P_FieldID
      
      StructName.s = FieldFromDescription(Secondary()\Field, P_Description)
      
      If StructName <> ""
        
        If SearchInternalStruct(StructName) <> -1
          
          ForEach General\Struct()\Fields()
            AddElement(Secondary()\SubField())
            Secondary()\SubField()\IsSubField = #True
            FieldFromDescription(Secondary()\SubField(), General\Struct()\Fields())
          Next
          
        EndIf
        
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure GenerateParamList()
    
    If General\UpdateInitParam = ""
      
      ForEach Primary()
        
        If Primary()\Field\Style = #FIELD_STYLE_BASIC
          
          If Primary()\Field\Name <> "ID"
            
            If Primary()\Field\Type = #FIELD_TYPE_STRING01
              Buffer.s + "P_" + Primary()\Field\Name + Primary()\Field\ExtensionShort
            ElseIf Primary()\Field\Type = #FIELD_TYPE_MODULE
              Buffer + "*P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort
            Else
              Buffer + "P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort
            EndIf 
            
            If ListIndex(Primary()) < ListSize(Primary()) - 1 
              Buffer + ", "
            EndIf
            
          EndIf
          
        EndIf 
        
      Next
      
      If Right(Buffer, 2) = ", "
        Buffer = Left(Buffer, Len(Buffer) - 2)
      EndIf
      
      General\UpdateInitParam = Buffer
      
    EndIf
    
  EndProcedure
  
  Procedure.l CountStructure()
    
    StructureCount.l = 1 + ListSize(General\Struct())
    
    If ListSize(Secondary()) <> 0
      StructureCount + 1
    EndIf
    
    ProcedureReturn StructureCount
  EndProcedure
  
  Procedure.s GenerateStructures(CallFrom.b)
    
    If CallFrom = 1
      
      If ListSize(General\Struct()) <> 0
        Output.s + GenerateInternalStruct(1)
      EndIf
      
      If ListSize(Secondary()) <> 0
        
        Output + Comments::Tabulation(1) + "Structure Secondary" + #TwinLineFeed
        
        ForEach Secondary()
          
          If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY
            Output + Comments::Tabulation(2) + Secondary()\Field\Name + Secondary()\Field\ExtensionLong + "[" + Secondary()\Field\ArraySizeCte + "]" + #LineFeed
          Else  
            Output + Comments::Tabulation(2) + Secondary()\Field\Description + #LineFeed
          EndIf
          
        Next
        
        Output + #LineFeed + Comments::Tabulation(1) + "EndStructure" + #TwinLineFeed
        
        SecondaryFlag.b = #True
        
      EndIf
      
    EndIf
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        Output + Comments::Tabulation(1) + "Structure Instance" + #TwinLineFeed
        
        ForEach Primary()
          If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY
            Output + Comments::Tabulation(2) + Primary()\Field\Name + Primary()\Field\ExtensionLong + "[" + Primary()\Field\ArraySizeCte + "]" + #LineFeed
          Else  
            Output + Comments::Tabulation(2) + Primary()\Field\Description + #LineFeed
          EndIf
        Next
        
        Output + #LineFeed + Comments::Tabulation(1) + "EndStructure" + #TwinLineFeed
        
        If SecondaryFlag.b = #True
          Output + Comments::Tabulation(1) + "Global Secondary.Secondary" + #LineFeed
        EndIf
        
        If General\InstanceStyle = #INSTANCE_STYLE_MULTIPLE_ID
          Output + Comments::Tabulation(1) + "Global NewList Instances.Instance()"
        ElseIf General\InstanceStyle = #INSTANCE_STYLE_MULTIPLE_INDEX
          Output + Comments::Tabulation(1) + "Global NewList Instances.Instance()"
        ElseIf General\InstanceStyle = #INSTANCE_STYLE_MULTIPLE_NAME
          Output + Comments::Tabulation(1) + "Global NewMap Instances.Instance()"
        Else
          Output + Comments::Tabulation(1) + "Global Instance.Instance"
        EndIf
        
      Case #INSTANCE_STYLE_OFF_MODULE
        Output.s = Comments::Tabulation(1) + "Structure " + General\ModuleName + #TwinLineFeed
        
        ForEach Primary()
          Output + Comments::Tabulation(2) + Primary()\Field\Description + #LineFeed
        Next
        
        Output + #LineFeed + Comments::Tabulation(1) + "EndStructure"
        
    EndSelect
    
    ProcedureReturn Output + #TwinLineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Generate Multiple Instance Helper <<<<<
  
  Procedure.s GenerateMultipleInstanceHelper(P_Mode.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_MULTIPLE_ID
        
        If P_Mode = #METHOD_MODE_DECLARE
          
          Output.s = Comments::Tabulation(1) + "Declare AddInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare SelectInstance(P_Index.l)" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare FirstInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare LastInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare PreviousInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare NextInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare DeleteInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ResetInstances()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ClearInstances()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare InstanceIndex()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare InstanceCount()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare.l SearchInstances(P_InstanceID.l)" + #LineFeed
          
          ForEach Primary()
            
            If Primary()\Field\Style = #FIELD_STYLE_BASIC
              If Primary()\Field\Name <> "ID"
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output + Comments::Tabulation(1) + "Declare.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
                ElseIf Primary()\Field\Type <= #FIELD_TYPE_DOUBLE
                  Output + Comments::Tabulation(1) + "Declare.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #LineFeed
                EndIf                
              EndIf
            EndIf
            
          Next 
          
        Else
          
          Output + Comments::Tabulation(1) + "Procedure AddInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "AddElement(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure SelectInstance(P_Index.l)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn SelectElement(Instances(), P_Index)" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure FirstInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn FirstElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure LastInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn LastElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure PreviousInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn PreviousElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure NextInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn NextElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure DeleteInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "DeleteElement(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed                    
          
          Output + Comments::Tabulation(1) + "Procedure ResetInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ResetList(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed        
          
          Output + Comments::Tabulation(1) + "Procedure ClearInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ClearList(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed        
          
          Output + Comments::Tabulation(1) + "Procedure InstanceIndex()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn ListIndex(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure InstanceCount()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn ListSize(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed

          Output + Comments::Tabulation(1) + "Procedure.l SearchInstances(P_InstanceID.l)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ForEach Instances()" + #TwinLineFeed
          Output + Comments::Tabulation(3) + "If Instances()\ID = P_InstanceID" + #LineFeed
          Output + Comments::Tabulation(4) + "IsFoundAtIndex = ListIndex(Instances())" + #LineFeed
          Output + Comments::Tabulation(4) + "Break" + #LineFeed
          Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "Next" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex"+ #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          ForEach Primary()
            
            If Primary()\Field\Style = #FIELD_STYLE_BASIC And Primary()\Field\Type < #FIELD_TYPE_MODULE
              
              If Primary()\Field\Name <> "ID"
               
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output + Comments::Tabulation(1) + "Procedure.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                  Flag = 1
                Else
                  Output + Comments::Tabulation(1) + "Procedure.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed 
                  Flag = 0
                EndIf       
                
                Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #TwinLineFeed
                
                If Primary()\Field\Type = #FIELD_TYPE_STRING01
                  ArraySizeLoop.s = "ForEach Instances()"
                  IndexName.s = "ListIndex(Instances())"
                  Test01.s = "UCase(Instances()\" + Primary()\Field\Name + "$) = UCase(P_" + Primary()\Field\Name + "$)"
                  Test02.s = "Instances()\" + Primary()\Field\Name + "$ = P_" + Primary()\Field\Name + "$"
                Else
                  ArraySizeLoop.s = "ForEach Instances()"
                  IndexName.s = "ListIndex(Instances())"
                  Test01.s = "UCase(Instances()\" + Primary()\Field\Name + ") = UCase(P_" + Primary()\Field\Name + ")"
                  Test02.s = "Instances()\" + Primary()\Field\Name + " = P_" + Primary()\Field\Name
                EndIf
                
                If Flag = 1
                  Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + #TwinLineFeed
                  Output + InsertLinearSearch(3, ArraySizeLoop, Test01, IndexName) + #LineFeed
                  Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                  Output + InsertLinearSearch(3, ArraySizeLoop, Test02, IndexName) + #LineFeed
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                Else 
                  Output + InsertLinearSearch(2, ArraySizeLoop, Test02, IndexName) + #LineFeed
                EndIf
                
                Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex"+ #LineFeed
                Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                
              EndIf
              
            EndIf
            
          Next
          
        EndIf
        
      Case #INSTANCE_STYLE_MULTIPLE_INDEX
        
        If P_Mode = #METHOD_MODE_DECLARE
          
          Output.s = Comments::Tabulation(1) + "Declare AddInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare SelectInstance(P_Index.l)" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare FirstInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare LastInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare PreviousInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare NextInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare DeleteInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ResetInstances()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ClearInstances()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare InstanceIndex()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare InstanceCount()" + #LineFeed
          
          ForEach Primary()
            
            If Primary()\Field\Style = #FIELD_STYLE_BASIC And Primary()\Field\Type < #FIELD_TYPE_MODULE
              If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                Output + Comments::Tabulation(1) + "Declare.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
              Else
                Output + Comments::Tabulation(1) + "Declare.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #LineFeed 
              EndIf
            EndIf
            
          Next

        Else
          
          Output + Comments::Tabulation(1) + "Procedure AddInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "AddElement(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure SelectInstance(P_Index.l)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn SelectElement(Instances(), P_Index)" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure FirstInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn FirstElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure LastInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn LastElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure PreviousInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn PreviousElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure NextInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn NextElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure DeleteInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "DeleteElement(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed                    
          
          Output + Comments::Tabulation(1) + "Procedure ResetInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ResetList(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed        
          
          Output + Comments::Tabulation(1) + "Procedure ClearInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ClearList(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed        
          
          Output + Comments::Tabulation(1) + "Procedure InstanceIndex()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn ListIndex(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure InstanceCount()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn ListSize(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          ForEach Primary()
            
            If Primary()\Field\Style = #FIELD_STYLE_BASIC And Primary()\Field\Type < #FIELD_TYPE_MODULE
              
              If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                Output + Comments::Tabulation(1) + "Procedure.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                Flag = 1
              Else
                Output + Comments::Tabulation(1) + "Procedure.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed 
                Flag = 0
              EndIf       
              
              Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #TwinLineFeed
              
              If Primary()\Field\Type = #FIELD_TYPE_STRING01
                ArraySizeLoop.s = "ForEach Instances()"
                IndexName.s = "ListIndex(Instances())"
                Test01.s = "UCase(Instances()\" + Primary()\Field\Name + "$) = UCase(P_" + Primary()\Field\Name + "$)"
                Test02.s = "Instances()\" + Primary()\Field\Name + "$ = P_" + Primary()\Field\Name + "$"
              Else
                ArraySizeLoop.s = "ForEach Instances()"
                IndexName.s = "ListIndex(Instances())"
                Test01.s = "UCase(Instances()\" + Primary()\Field\Name + ") = UCase(P_" + Primary()\Field\Name + ")"
                Test02.s = "Instances()\" + Primary()\Field\Name + " = P_" + Primary()\Field\Name
              EndIf
              
              If Flag = 1
                Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + #TwinLineFeed
                Output + InsertLinearSearch(3, ArraySizeLoop, Test01, IndexName) + #LineFeed
                Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                Output + InsertLinearSearch(3, ArraySizeLoop, Test02, IndexName) + #LineFeed
                Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
              Else 
                Output + InsertLinearSearch(2, ArraySizeLoop, Test02, IndexName) + #LineFeed
              EndIf
              
              Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex"+ #LineFeed
              Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
              
            EndIf
            
          Next

        EndIf
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        
        If P_Mode = #METHOD_MODE_DECLARE
          
          Output = Comments::Tabulation(1) + "Declare AddInstance(P_Key.s)" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare FindInstance(P_Key.s)" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare NextInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare DeleteInstance(P_Key.s)" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ResetInstances()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ClearInstances()" + #LineFeed
          
        Else
          
          Output + Comments::Tabulation(1) + "Procedure AddInstance(P_Key.s)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "AddMapElement(Instances(), P_Key)" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure FindInstance(P_Key.s)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn FindMapElement(Instance(), P_Key)"+ #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure NextInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn NextMapElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure DeleteInstance(P_Key.s)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "DeleteMapElement(Instances(), P_Key)" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed     
          
          Output + Comments::Tabulation(1) + "Procedure ResetInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ResetMap(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed        

          Output + Comments::Tabulation(1) + "Procedure ClearInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ClearMap(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed       
          
        EndIf
        
    EndSelect 
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Utilitaires <<<<<
  
  Procedure.b IsSquareMatrix()
    
    ProcedureReturn General\IsSquareMatrix
  EndProcedure
  
  Procedure.b IsMatrix()
    
    ProcedureReturn General\IsMatrix
  EndProcedure
  
  Procedure.b GetMatrixSizeI()
    
    ProcedureReturn General\MatrixSizeI
  EndProcedure
  
  Procedure.b GetMatrixSizeJ()
    
    ProcedureReturn General\MatrixSizeJ
  EndProcedure
  
  Procedure.b IsDatabaseHelperNeeded(Flag.b = -1)
    
    If Flag >= 0
      General\IsDatabaseHelperNeeded = Flag
    Else
      ProcedureReturn General\IsDatabaseHelperNeeded
    EndIf
    
  EndProcedure

  Procedure.l CountInstances(Flag.b = 0)
    
    If Flag = 0
      Count.l = ListSize(Primary())
    Else
      Count.l = ListSize(Secondary())
    EndIf
    
    ProcedureReturn Count
  EndProcedure
  
  Procedure GetSpecialMethods()
    
    ProcedureReturn General\SpecialMethods
  EndProcedure
  
  Procedure GadgetLinking(GadgetID, Flag)
    
    Select Flag
        
      Case 0
        General\EncodedModuleGadget = GadgetID
        
      Case 1
        General\CryptedModuleGadget = GadgetID
        
      Case 2
        General\InternalStructListViewGadget = GadgetID 
        
      Case 3
        General\InternalStructEditorGadget = GadgetID
        
    EndSelect
    
  EndProcedure
  
  Procedure FileModuleScanning(*FileModuleA.FileModule)
    
    FileID = ReadFile(#PB_Any, *FileModuleA\FileName)
    
    If IsFile(FileID)
      
      Exit_Condition = #False
      
      While Exit_Condition = #False
        
        Line.s = Trim(ReadString(FileID))
        
        If Line <> ""
          
          If *FileModuleA\Name = ""
            If FindString(Line, "DeclareModule")
              *FileModuleA\DisplayName = ReplaceString(RemoveString(Line, "DeclareModule "), ";", " - ")
              *FileModuleA\Name = Trim(StringField(*FileModuleA\DisplayName, 1, "-"))
            EndIf
          EndIf
          
          If *FileModuleA\Prefix = ""
            If FindString(Line, "Write")
              *FileModuleA\Prefix = Trim(StringBetween::FindIt(Line, "Declare", "Write"))
            EndIf
          EndIf
          
          If FindString(Line, "EndDeclareModule")
            Exit_Condition = #True
          EndIf
          
        EndIf
        
      Wend
      
      CloseFile(FileID)
      
    EndIf
    
  EndProcedure
  
  Procedure FileModule_To_GUI()
    
    ClearGadgetItems(General\EncodedModuleGadget)
    ClearGadgetItems(General\CryptedModuleGadget)
    
    ForEach General\EncodedModule()
      FileModuleScanning(General\EncodedModule())
    Next
    
    ForEach General\CryptedModule()
      FileModuleScanning(General\CryptedModule())
    Next  
    
    SortStructuredList(General\EncodedModule(), #PB_Sort_Ascending, OffsetOf(FileModule\Name), #PB_String)
    SortStructuredList(General\CryptedModule(), #PB_Sort_Ascending, OffsetOf(FileModule\Name), #PB_String)
    
    ForEach General\EncodedModule()
      AddGadgetItem(General\EncodedModuleGadget, ListIndex(General\EncodedModule()), General\EncodedModule()\DisplayName)
    Next
    
    ForEach General\CryptedModule()
      AddGadgetItem(General\CryptedModuleGadget, ListIndex(General\CryptedModule()), General\CryptedModule()\DisplayName)
    Next  
    
    SetGadgetState(General\EncodedModuleGadget, 0)
    SetGadgetState(General\CryptedModuleGadget, 0)
    SelectElement(General\EncodedModule(), 0)
    SelectElement(General\CryptedModule(), 0)
    
  EndProcedure
  
  Procedure To_GUI(Mode.b = 0)
    
    If Mode = 0
      
      If ListIndex(General\EncodedModule()) <> -1
        SetGadgetState(General\EncodedModuleGadget, ListIndex(General\EncodedModule()))
      EndIf
      
      If ListIndex(General\CryptedModule()) <> -1
        SetGadgetState(General\CryptedModuleGadget, ListIndex(General\CryptedModule()))
      EndIf
      
      ForEach General\Struct()
        AddGadgetItem(General\InternalStructListViewGadget, -1, General\Struct()\Name)
      Next
      
    ElseIf Mode = 1
      
      ClearGadgetItems(General\InternalStructEditorGadget)
      
      ForEach General\Struct()\Fields()
        AddGadgetItem(General\InternalStructEditorGadget, -1, General\Struct()\Fields())
      Next
      
    EndIf
    
  EndProcedure
  
  Procedure From_GUI(Mode.b = 0)
    
    If Mode = 0
      
      If CountGadgetItems(General\EncodedModuleGadget) > 0
        
        EncodedModule = GetGadgetState(General\EncodedModuleGadget)
        
        If EncodedModule <> -1
          SelectElement(General\EncodedModule(), EncodedModule)
        EndIf
        
      EndIf
      
      If CountGadgetItems(General\CryptedModuleGadget) > 0
        
        CryptedModule = GetGadgetState(General\CryptedModuleGadget)
        
        If CryptedModule <> -1
          SelectElement(General\CryptedModule(), CryptedModule)
        EndIf
        
        
      EndIf
      
    ElseIf Mode = 1
      
      ForEach General\Struct()\Fields()
        General\Struct()\Fields() = ""
      Next
      
      ClearList(General\Struct()\Fields())
      
      FieldMax = CountGadgetItems(General\InternalStructEditorGadget) - 1
      
      For FieldID = 0 To FieldMax 
        AddElement(General\Struct()\Fields())
        General\Struct()\Fields() = GetGadgetItemText(General\InternalStructEditorGadget, FieldID)
      Next
      
    EndIf
    
  EndProcedure
  
  Procedure.l SearchEncodedModuleName(P_Name.s)
    
    Protected IsFoundAtIndex.l = -1
    
    ForEach General\EncodedModule()
      
      If General\EncodedModule()\Name = P_Name
        IsFoundAtIndex = ListIndex(General\EncodedModule())
        Break
      EndIf
      
    Next
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure.l SearchCryptedModuleName(P_Name.s)
    
    Protected IsFoundAtIndex.l = -1
    
    ForEach General\CryptedModule()
      
      If General\CryptedModule()\Name = P_Name
        IsFoundAtIndex = ListIndex(General\CryptedModule())
        Break
      EndIf
      
    Next
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure AddFileModule(Flag.b)
    
    FileName.s = OpenFileRequester(Language::Message("Read/Write external module"), GetHomeDirectory(), Language::Message("PureBasic SourceCode (*.pb)|*.pb"), 1, #PB_Requester_MultiSelection)
    
    If FileName <> ""
      
      While FileName
        
        Select Flag
            
          Case 0
            AddElement(General\EncodedModule())
            General\EncodedModule()\FileName = FileName
            
          Case 1
            AddElement(General\CryptedModule())
            General\CryptedModule()\FileName = FileName
            
        EndSelect 
        
        FileName = NextSelectedFileName()
        
      Wend
      
      FileModule_To_GUI()
      
    EndIf
    
  EndProcedure
  
  Procedure RemoveFileModule(Flag.b)
    
    Select Flag
        
      Case 0
        
        If CountGadgetItems(General\EncodedModuleGadget) >= 1
          
          Message.s = ReplaceString(Language::Message("You are about to remove the %MODULE_NAME% module. Are you sure ?"), "%MODULE_NAME%", GetGadgetText(General\EncodedModuleGadget))
          
          If MessageRequester(Language::Message("Dev-Module - Warning"), Message, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
            
            EncodedModule = GetGadgetState(General\EncodedModuleGadget)
            
            If EncodedModule <> -1
              SelectElement(General\EncodedModule(), EncodedModule)
              DeleteElement(General\EncodedModule())
            EndIf
            
            FileModule_To_GUI()
            
          EndIf
          
        EndIf
      
      Case 1
        
        If CountGadgetItems(General\CryptedModuleGadget) >= 1
          
          Message.s = ReplaceString(Language::Message("You are about to remove the %MODULE_NAME% module. Are you sure ?"), "%MODULE_NAME%", GetGadgetText(General\CryptedModuleGadget))
          
          If MessageRequester(Language::Message("Dev-Module - Warning"), Message, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
            
            CryptedModule = GetGadgetState(General\CryptedModuleGadget)
            
            If CryptedModule <> -1
              SelectElement(General\CryptedModule(), CryptedModule)
              DeleteElement(General\CryptedModule())
            EndIf 
            
            FileModule_To_GUI()
            
          EndIf
          
        EndIf
      
    EndSelect 
    
  EndProcedure
  
  Procedure.s CurrentFileModuleName(Flag.b, Input.s = "")
    
    If Input = ""
      
      Select Flag
          
        Case 0
          Output.s = General\EncodedModule()\Name
          
        Case 1
          Output = General\CryptedModule()\Name
          
      EndSelect
      
    Else
 
      Select Flag
          
        Case 0
          
          If SearchEncodedModuleName(Trim(StringField(Input, 1, "-"))) = -1
            FirstElement(General\EncodedModule())
          EndIf
          
        Case 1
          
          If SearchCryptedModuleName(Trim(StringField(Input, 1, "-"))) = -1
            FirstElement(General\CryptedModule())
          EndIf
          
      EndSelect
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure LoadProjectFile()
    
    PreferenceGroup("ModuleDefinition")
    
    General\ModuleName = ReadPreferenceString("ModuleName", "")
    General\InstanceStyle = ReadPreferenceLong("InstanceStyle", 0)
    
    PreferenceGroup("PrimaryField")
    
    Field_Max = ReadPreferenceLong("Field_Max", 0) - 1
    
    For FieldID = 0 To Field_Max
      New(0, FieldID, ReadPreferenceString("Description_" + Str(FieldID), ""))
    Next
    
    PreferenceGroup("SecondaryField")
    
    Field_Max = ReadPreferenceLong("Field_Max", 0) - 1
    
    For FieldID = 0 To Field_Max
      New(1, FieldID, ReadPreferenceString("Description_" + Str(FieldID), ""))
    Next
    
    PreferenceGroup("InternalStructure")
    
    StructMax = ReadPreferenceLong("StructMax", 0) - 1
    
    For StructID = 0 To StructMax
      
      AddInternalStruct(ReadPreferenceString("StructName_" + Str(StructID), ""))
      StructFieldMax.l = ReadPreferenceLong("StructFieldMax_" + Str(StructID), 0) - 1
      
      For FieldID = 0 To StructFieldMax
        AddInternalStructField(General\Struct()\Name, ReadPreferenceString("StructField_" + Str(StructID) + "_" + Str(FieldID), ""))
      Next
      
    Next
    
  EndProcedure
  
  Procedure SaveProjectFile()
    
    PreferenceGroup("ModuleDefinition")
    
    WritePreferenceString("ModuleName", General\ModuleName)
    WritePreferenceLong("InstanceStyle", General\InstanceStyle)
    
    PreferenceGroup("PrimaryField")
    WritePreferenceLong("Field_Max", ListSize(Primary()))
    
    ForEach Primary()
      WritePreferenceString("Description_" + Str(ListIndex(Primary())), Primary()\Field\Description)
    Next
    
    PreferenceGroup("SecondaryField")
    WritePreferenceLong("Field_Max", ListSize(Secondary()))
    
    ForEach Secondary()
      WritePreferenceString("Description_" + Str(ListIndex(Secondary())), Secondary()\Field\Description)
    Next
    
    PreferenceGroup("InternalStructure")
    
    WritePreferenceLong("StructMax", ListSize(General\Struct()))
    
    ForEach General\Struct()
      
      WritePreferenceString("StructName_" + Str(ListIndex(General\Struct())), General\Struct()\Name)
      WritePreferenceLong("StructFieldMax_" + Str(ListIndex(General\Struct())), ListSize(General\Struct()\Fields()))
      
      ForEach General\Struct()\Fields()
        WritePreferenceString("StructField_" + Str(ListIndex(General\Struct())) + "_" + Str(ListIndex(General\Struct()\Fields())), General\Struct()\Fields())
      Next
      
    Next
    
  EndProcedure
   
  Procedure ReadPrefs(P_GroupName.s)
    
    PreferenceGroup(P_GroupName)
    
    EncodedModule_Max.l = ReadPreferenceLong("EncodedModule_Max", 0) - 1
    
    For EncodedModuleID = 0 To EncodedModule_Max
      AddElement(General\EncodedModule())
      General\EncodedModule()\FileName = ReadPreferenceString("EncodedModuleFileName_" + Str(EncodedModuleID), General\EncodedModule()\FileName)
    Next
    
    CryptedModule_Max.l = ReadPreferenceLong("CryptedModule_Max", 0) - 1
    
    For CryptedModuleID = 0 To CryptedModule_Max
      AddElement(General\CryptedModule())
      General\CryptedModule()\FileName = ReadPreferenceString("CryptedModuleFileName_" + Str(CryptedModuleID), General\CryptedModule()\FileName)
    Next
    
    FirstElement(General\EncodedModule())    
    FirstElement(General\CryptedModule())
    
  EndProcedure
  
  Procedure WritePrefs(P_GroupName.s)
    
    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("EncodedModule_Max", ListSize(General\EncodedModule()))
    
    ForEach General\EncodedModule()
      WritePreferenceString("EncodedModuleFileName_" + Str(ListIndex(General\EncodedModule())), General\EncodedModule()\FileName)
    Next
    
    WritePreferenceLong("CryptedModule_Max", ListSize(General\CryptedModule()))
    
    ForEach General\CryptedModule()
      WritePreferenceString("CryptedModuleFileName_" + Str(ListIndex(General\CryptedModule())), General\CryptedModule()\FileName)
    Next
    
  EndProcedure
  
  Procedure Reset(Style.b)
    
    Select Style
        
      Case #RESET_STYLE_TERMINAL
        
        ForEach Primary()
          
          Primary()\ID = 0
          ClearStructure(@Primary()\Field, Field)
          
          ForEach Primary()\SubField()
            ClearStructure(@Primary()\SubField(), Field)
          Next
          
          FreeList(Primary()\SubField())
          
        Next
        
        FreeList(Primary())
        
        ForEach Secondary()
          
          Secondary()\ID = 0
          ClearStructure(@Secondary()\Field, Field)
          
          ForEach Secondary()\SubField()
            ClearStructure(@Secondary()\SubField(), Field)
          Next
          
          FreeList(Secondary()\SubField())
          
        Next
        
        FreeList(Secondary())
        
        General\UpdateInitParam = ""
        General\ModuleName = ""
        General\InstanceID = ""
        General\SpecialMethods = 0 
        General\GenerateEnumConstants = 0
        General\SizeConstants = 0
        
        General\IsLinkedListPresent = 0
        General\IsDynamicArrayPresent = 0
        General\IsStaticArrayPresent = 0
        
        General\StaticArray = 0
        General\StaticArrayFieldName = 0
        General\InstanceStyle = 0
        General\IsMatrix = 0
        General\IsSquareMatrix = 0
        General\MatrixSizeI = 0
        General\MatrixSizeJ = 0
        
        ForEach General\EncodedModule()
          General\EncodedModule()\Name = ""
          General\EncodedModule()\DisplayName = ""
          General\EncodedModule()\FileName = ""
          General\EncodedModule()\Prefix = ""
        Next
        
        FreeList(General\EncodedModule())
        
        ForEach General\CryptedModule()
          General\CryptedModule()\Name = ""
          General\CryptedModule()\DisplayName = ""
          General\CryptedModule()\FileName = ""
          General\CryptedModule()\Prefix = ""
        Next
        
        ForEach General\Struct()
          
          General\Struct()\Name = ""
          
          ForEach General\Struct()\Fields()
            General\Struct()\Fields() = ""
          Next
          
          FreeList(General\Struct()\Fields())
          
        Next    	  
        
        FreeList(General\Struct())
        
      Case #RESET_STYLE_NEW_MODULE
        
        ForEach Primary()
          
          Primary()\ID = 0
          ClearStructure(@Primary()\Field, Field)
          
          ForEach Primary()\SubField()
            ClearStructure(@Primary()\SubField(), Field)
          Next
          
          ClearList(Primary()\SubField())
          
        Next
        
        ClearList(Primary())
        
        
        ForEach Secondary()
          
          Secondary()\ID = 0
          ClearStructure(@Secondary()\Field, Field)
          
          ForEach Secondary()\SubField()
            ClearStructure(@Secondary()\SubField(), Field)
          Next
          
          ClearList(Secondary()\SubField())
          
        Next
        
        ClearList(Secondary())
        
        General\UpdateInitParam = ""
        General\ModuleName = ""
        General\InstanceID = ""
        General\SpecialMethods = 0 
        General\GenerateEnumConstants = 0
        General\SizeConstants = 0
        General\IsLinkedListPresent = 0
        General\IsDynamicArrayPresent = 0
        General\IsStaticArrayPresent = 0
        General\StaticArray = 0
        General\StaticArrayFieldName = 0
        General\InstanceStyle = 0
        General\IsMatrix = 0
        General\IsSquareMatrix = 0
        General\MatrixSizeI = 0
        General\MatrixSizeJ = 0
        
        ForEach General\Struct()
          
          General\Struct()\Name = ""
          
          ForEach General\Struct()\Fields()
            General\Struct()\Fields() = ""
          Next
          
          ClearList(General\Struct()\Fields())
          
        Next    	  
        
        ClearList(General\Struct())
       
      Case #RESET_STYLE_AFTER_RUN
        
        ForEach Primary()
          
          Primary()\ID = 0
          ClearStructure(@Primary()\Field, Field)
          
          ForEach Primary()\SubField()
            ClearStructure(@Primary()\SubField(), Field)
          Next
          
          ClearList(Primary()\SubField())
          
        Next
        
        ClearList(Primary())
        
        ForEach Secondary()
          
          Secondary()\ID = 0
          ClearStructure(@Secondary()\Field, Field)
          
          ForEach Secondary()\SubField()
            ClearStructure(@Secondary()\SubField(), Field)
          Next
          
          ClearList(Secondary()\SubField())
          
        Next
        
        ClearList(Secondary())
        
        General\UpdateInitParam = ""
        General\ModuleName = ""
        General\InstanceID = ""
        General\SpecialMethods = 0 
        General\GenerateEnumConstants = 0
        General\SizeConstants = 0
        General\IsLinkedListPresent = 0
        General\IsDynamicArrayPresent = 0
        General\IsStaticArrayPresent = 0
        General\StaticArray = 0
        General\StaticArrayFieldName = 0
        General\InstanceStyle = 0
        General\IsMatrix = 0
        General\IsSquareMatrix = 0
        General\MatrixSizeI = 0
        General\MatrixSizeJ = 0
        
      Case #RESET_STYLE_FLUSH_INTERNAL_STRUCTURE
        
        ForEach General\Struct()
          
          General\Struct()\Name = ""
          
          ForEach General\Struct()\Fields()
            General\Struct()\Fields() = ""
          Next
          
          ClearList(General\Struct()\Fields())
          
        Next    	  
        
        ClearList(General\Struct())
        
    EndSelect
    
  EndProcedure
 
  Procedure.s GetModuleName()
    
    ProcedureReturn General\ModuleName
  EndProcedure
  
  Procedure SetModuleName(P_ModuleName.s)
    
    General\ModuleName = P_ModuleName
    
    If Left(General\ModuleName, Len(General\ModuleName)-2) = "Matrix"
      
      General\IsMatrix = #True
      
      Size.s = Right(General\ModuleName, 2)
      
      General\MatrixSizeI = Val(Mid(Size, 1, 1))
      General\MatrixSizeJ = Val(Mid(Size, 2, 1))
      
      If General\MatrixSizeI = General\MatrixSizeJ
        General\IsSquareMatrix = #True
      Else
        General\IsSquareMatrix = #False
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure.b GetInstanceStyle()
    
    ProcedureReturn General\InstanceStyle
  EndProcedure
  
  Procedure SetInstanceStyle(P_InstanceStyle.b)
    
    General\InstanceStyle = P_InstanceStyle
    
  EndProcedure
  
  Procedure.s GetInstanceID()
    
    ProcedureReturn General\InstanceID
  EndProcedure
  
  Procedure.b GetSecondaryInstance()
    
    ProcedureReturn General\SecondaryInstance
  EndProcedure
  
  Procedure SetSecondaryInstance(P_SecondaryInstance.b)
    
    General\SecondaryInstance = P_SecondaryInstance
    
  EndProcedure 

  Procedure FirstInternalStruct()
    
    ProcedureReturn FirstElement(General\Struct())
  EndProcedure
  
  Procedure NextInternalStruct()
    
    ProcedureReturn NextElement(General\Struct())
  EndProcedure 
  
  Procedure FirstInternalStructFields()
    
    ProcedureReturn FirstElement(General\Struct()\Fields())
  EndProcedure
  
  Procedure NextInternalStructFields()
    
    ProcedureReturn NextElement(General\Struct()\Fields())
  EndProcedure 
  
  Procedure InternalStructFieldsIndex()
    
    ProcedureReturn ListIndex(General\Struct()\Fields())
  EndProcedure
  
  Procedure InternalStructFieldsSize()
    
    ProcedureReturn ListSize(General\Struct()\Fields())
  EndProcedure 
  
  Procedure.s GetInternalStructFields()
  
    ProcedureReturn General\Struct()\Fields()
  EndProcedure
 
  Procedure FirstInstance(Target.b)
    
    If Target = 0
      ProcedureReturn FirstElement(Primary())
    ElseIf Target = 1
      ProcedureReturn FirstElement(Secondary())
    EndIf
    
  EndProcedure

  Procedure NextInstance(Target.b)
    
    If Target = 0
      ProcedureReturn NextElement(Primary())
    ElseIf Target = 1
      ProcedureReturn NextElement(Secondary())
    EndIf
    
  EndProcedure
  
  Procedure InstanceIndex(Target.b)
    
    If Target = 0
      ProcedureReturn ListIndex(Primary())
    ElseIf Target = 1
      ProcedureReturn ListIndex(Secondary())
    EndIf
    
  EndProcedure
  
  Procedure InstanceSize(Target.b)
    
    If Target = 0
      ProcedureReturn ListSize(Primary())
    ElseIf Target = 1
      ProcedureReturn ListSize(Secondary())
    EndIf
    
  EndProcedure
  
  Procedure FirstSubField(Target.b)
    
    If Target = 0
      ProcedureReturn FirstElement(Primary()\SubField())
    ElseIf Target = 1
      ProcedureReturn FirstElement(Secondary()\SubField())
    EndIf
    
  EndProcedure
  
  Procedure NextSubField(Target.b)
    
    If Target = 0
      ProcedureReturn NextElement(Primary()\SubField())
    ElseIf Target = 1
      ProcedureReturn NextElement(Secondary()\SubField())
    EndIf
    
  EndProcedure
  
  Procedure SubFieldIndex(Target.b)
    
    If Target = 0 
      ProcedureReturn ListIndex(Primary()\SubField())
    ElseIf Target = 1
      ProcedureReturn ListIndex(Secondary()\SubField())
    EndIf
    
  EndProcedure
  
  Procedure SubFieldSize(Target.b)
    
    If Target = 0
      ProcedureReturn ListSize(Primary()\SubField())
    ElseIf Target = 1
      ProcedureReturn ListSize(Secondary()\SubField())
    EndIf
    
  EndProcedure
  
  Procedure.s GetFieldDescription(Target.b) 
    
    If Target = 0
      Output.s = Primary()\Field\Description
    ElseIf Target = 1
      Output.s = Secondary()\Field\Description
    EndIf
   
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetFieldName(Target.b) 
    
    If Target = 0
      Output.s = Primary()\Field\Name
    ElseIf Target = 1
      Output.s = Secondary()\Field\Name
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.b GetFieldType(Target.b)
    
    If Target = 0
      Output.b = Primary()\Field\Type
    ElseIf Target = 1
      Output = Secondary()\Field\Type
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.b GetFieldStyle(Target.b)
    
    If Target = 0
      Output.b = Primary()\Field\Style
    ElseIf Target = 1
      Output = Secondary()\Field\Style
    EndIf
    
    ProcedureReturn Output
  EndProcedure

  Procedure.s GetFieldExtensionShort(Target.b)
    
    If Target = 0 
      Output.s = Primary()\Field\ExtensionShort  
    ElseIf Target = 1
      Output = Secondary()\Field\ExtensionShort  
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetFieldExtensionLong(Target.b)
    
    If Target = 0 
      Output.s = Primary()\Field\ExtensionLong
    ElseIf Target = 1
      Output = Secondary()\Field\ExtensionLong
    EndIf
    
    ProcedureReturn Output
  EndProcedure

  Procedure.b GetFieldDynamicArrayDimensionCount(Target.b)
    
    If Target = 0
      Output.b = Primary()\Field\DynamicArrayDimensionCount
    ElseIf Target = 1
      Output = Secondary()\Field\DynamicArrayDimensionCount
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetFieldDynamicArrayDimensionIndexName(Target.b, P_Index.b)
    
    If Target = 0
      Output.s = Primary()\Field\DynamicArrayDimensionIndexName[P_Index]
    ElseIf Target = 1
      Output = Secondary()\Field\DynamicArrayDimensionIndexName[P_Index]
    EndIf
    
    ProcedureReturn Output
  EndProcedure

  Procedure.s GetFieldExternModuleName(Target.b)
    
    If Target = 0
      Output.s = Primary()\Field\ExternModuleName
    ElseIf Target = 1
      Output = Secondary()\Field\ExternModuleName
    EndIf
   
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetFieldExternModuleStructure(Target.b)
    
    If Target = 0
      Output.s = Primary()\Field\ExternModuleStructure
    ElseIf Target = 1
      Output = Secondary()\Field\ExternModuleStructure
    EndIf
   
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetFieldAccess(Target.b)
    
    If Target = 0
      Output.s = Primary()\Field\Access
    ElseIf Target = 1
      Output = Secondary()\Field\Access
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetFieldAccessEmpty(Target.b)
    
    If Target = 0
      Output.s = Primary()\Field\AccessEmpty
    ElseIf Target = 1
      Output = Secondary()\Field\AccessEmpty
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetFieldAccessMax(Target.b)
    
    If Target = 0
      Output.s = Primary()\Field\AccessMax
    ElseIf Target = 1
      Output = Secondary()\Field\AccessMax
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetFieldArrayIndexName(Target.b)
    
    If Target = 0
      Output.s = Primary()\Field\ArrayIndexName
    ElseIf Target = 1
      Output = Secondary()\Field\ArrayIndexName
    EndIf
    
    ProcedureReturn Output
  EndProcedure

  Procedure.s GetFieldArraySizeLoop(Target.b)
    
    If Target = 0
      Output.s = Primary()\Field\ArraySizeLoop
    ElseIf Target = 1
      Output = Secondary()\Field\ArraySizeLoop
    EndIf
    
    ProcedureReturn Output
  EndProcedure

  Procedure.b GetSubFieldType(Target.b)
    
    If Target = 0
      Output.b = Primary()\SubField()\Type
    ElseIf Target = 1
      Output = Secondary()\SubField()\Type
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.b GetSubFieldStyle(Target.b)
    
    If Target = 0
      Output.b = Primary()\SubField()\Style
    ElseIf Target = 1
      Output = Secondary()\SubField()\Style
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetSubFieldAccess(Target.b)
    
    If Target = 0
      Output.s = Primary()\SubField()\Access
    ElseIf Target = 1
      Output = Secondary()\SubField()\Access
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetSubFieldAccessEmpty(Target.b)
    
    If Target = 0
      Output.s = Primary()\SubField()\AccessEmpty
    ElseIf Target = 1
      Output = Secondary()\SubField()\AccessEmpty
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetSubFieldAccessMax(Target.b)
    
    If Target = 0
      Output.s = Primary()\SubField()\AccessMax
    ElseIf Target = 1
      Output = Secondary()\SubField()\AccessMax
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetSubFieldName(Target.b) 
    
    If Target = 0
      Output.s = Primary()\SubField()\Name
    ElseIf Target = 1
      Output.s = Secondary()\SubField()\Name
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.b GetSubFieldDynamicArrayDimensionCount(Target.b)
    
    If Target = 0
      Output.b = Primary()\SubField()\DynamicArrayDimensionCount
    ElseIf Target = 1
      Output = Secondary()\SubField()\DynamicArrayDimensionCount
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetSubFieldDynamicArrayDimensionIndexName(Target.b, P_Index.b)
    
    If Target = 0
      Output.s = Primary()\SubField()\DynamicArrayDimensionIndexName[P_Index]
    ElseIf Target = 1
      Output = Secondary()\SubField()\DynamicArrayDimensionIndexName[P_Index]
    EndIf
    
    ProcedureReturn Output
  EndProcedure
    
  Procedure.s GetSubFieldExternModuleName(Target.b)
    
    If Target = 0
      Output.s = Primary()\SubField()\ExternModuleName
    ElseIf Target = 1
      Output = Secondary()\SubField()\ExternModuleName
    EndIf
   
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetSubFieldExternModuleStructure(Target.b)
    
    If Target = 0
      Output.s = Primary()\SubField()\ExternModuleStructure
    ElseIf Target = 1
      Output = Secondary()\SubField()\ExternModuleStructure
    EndIf
   
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetSubFieldArrayIndexName(Target.b)
    
    If Target = 0
      Output.s = Primary()\SubField()\ArrayIndexName
    ElseIf Target = 1
      Output = Secondary()\SubField()\ArrayIndexName
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetSubFieldArraySizeLoop(Target.b)
    
    If Target = 0
      Output.s = Primary()\SubField()\ArraySizeLoop
    ElseIf Target = 1
      Output = Secondary()\SubField()\ArraySizeLoop
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GetSubFieldExtensionLong(Target.b)
    
    If Target = 0 
      Output.s = Primary()\SubField()\ExtensionLong
    ElseIf Target = 1
      Output = Secondary()\SubField()\ExtensionLong
    EndIf
    
    ProcedureReturn Output
  EndProcedure

  Procedure.s GetDynamicArrayOpeningLoop(Target.b, *Ptr_TabSize, SubTarget.b)
    
    TabSize.b = PeekB(*Ptr_TabSize)
    
    Buffer.s = ""
    
    Select Target
        
      Case 0
        
        If SubTarget = 0
          
          For Index = Primary()\Field\DynamicArrayDimensionCount To 1 Step -1 
            
            Buffer + Comments::Tabulation(TabSize) + "For " + Primary()\Field\DynamicArrayDimensionIndexName[Index - 1] + " = 0 To " + DynamicArraySize(Primary()\Field, Str(Index), #CAME_FROM_PRIMARY) + #LineFeed
            
            If Index > 1
              TabSize + 1
            EndIf 
            
          Next 
          
        ElseIf SubTarget = 1
          
          For Index = Primary()\SubField()\DynamicArrayDimensionCount To 1 Step -1 
            
            Buffer + Comments::Tabulation(TabSize) + "For " + Primary()\SubField()\DynamicArrayDimensionIndexName[Index - 1] + " = 0 To " + DynamicArraySize(Primary()\SubField(), Str(Index), #CAME_FROM_PRIMARY, Primary()\Field) + #LineFeed
            
            If Index > 1
              TabSize + 1
            EndIf 
            
          Next 
          
        EndIf
        
      Case 1
        If SubTarget = 0
          For Index = Secondary()\Field\DynamicArrayDimensionCount To 1 Step -1 
            
            Buffer + Comments::Tabulation(TabSize) + "For " + Secondary()\Field\DynamicArrayDimensionIndexName[Index - 1] + " = 0 To " + DynamicArraySize(Secondary()\Field, Str(Index), #CAME_FROM_SECONDARY) + #LineFeed
            
            If Index > 1
              TabSize + 1
            EndIf 
            
          Next 
        ElseIf SubTarget = 1
          For Index = Secondary()\SubField()\DynamicArrayDimensionCount To 1 Step -1 
            
            Buffer + Comments::Tabulation(TabSize) + "For " + Secondary()\SubField()\DynamicArrayDimensionIndexName[Index - 1] + " = 0 To " + DynamicArraySize(Secondary()\SubField(), Str(Index), #CAME_FROM_SECONDARY, Secondary()\Field) + #LineFeed
            
            If Index > 1
              TabSize + 1
            EndIf 
            
          Next
        EndIf
        
    EndSelect 
    
    PokeB(*Ptr_TabSize, TabSize)
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s GetDynamicArrayClosingLoop(Target.b, *Ptr_TabSize, SubTarget.b)
    
    TabSize.b = PeekB(*Ptr_TabSize)
    Buffer.s = ""
    
    Select Target
        
      Case 0
        If SubTarget = 0
          Max = Primary()\Field\DynamicArrayDimensionCount
        ElseIf SubTarget = 1
          Max = Primary()\SubField()\DynamicArrayDimensionCount
        EndIf
        
      Case 1
        If SubTarget = 0
          Max = Secondary()\Field\DynamicArrayDimensionCount
        ElseIf SubTarget = 1
          Max = Secondary()\SubField()\DynamicArrayDimensionCount
        EndIf
        
    EndSelect

    For Index = Max To 1 Step -1 
      
      Buffer + Comments::Tabulation(TabSize) + "Next"
      
      If Index > 1
        TabSize = TabSize - 1
        Buffer + #LineFeed
      EndIf 
      
    Next 
    
    PokeB(*Ptr_TabSize, TabSize)
    
    ProcedureReturn Buffer
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Nom de la procdure <<<<<
  
  Procedure.s GetUpdateInitParam()
  
    ProcedureReturn General\UpdateInitParam
  EndProcedure
  
  Procedure.s GetInstanceParam()
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        Output.s = ""
        
      Case #INSTANCE_STYLE_MULTIPLE_ID
        Output = "P_InstanceID.l"
        
      Case #INSTANCE_STYLE_MULTIPLE_INDEX
        Output = "P_Index.l"
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        Output = "P_Name.s"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        Output = "*" + General\ModuleName + "A." + General\ModuleName
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure

  Procedure.s GetExtraParam()
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""

      Case #INSTANCE_STYLE_MULTIPLE_ID
        ExtraParam.s = ", P_InstanceID.l = -1"
        
      Case #INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", P_Index.l = -1"

      Case #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", P_Name.s = " + #EmptyString

      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General\ModuleName + "A." + General\ModuleName
 
    EndSelect
    
    ProcedureReturn ExtraParam
  EndProcedure
  
  Procedure.s GetInstanceAccessPath() 
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    ProcedureReturn InstanceStyle
  EndProcedure
 
  Procedure.s GetStructName()
  
    ProcedureReturn General\Struct()\Name
  EndProcedure
 
  Procedure.b IsLinkedListPresent()
  
    ProcedureReturn General\IsLinkedListPresent
  EndProcedure
  
  Procedure.b IsDynamicArrayPresent()
  
    ProcedureReturn General\IsDynamicArrayPresent
  EndProcedure
  
  Procedure.b IsStaticArrayPresent()
    
    ProcedureReturn General\IsStaticArrayPresent
  EndProcedure
  
  Procedure.s FormatEncodedFileModule(Flag.b = 0)
    
    If Flag = 0 
      Output.s = General\EncodedModule()\Name + "::" + General\EncodedModule()\Prefix
    Else
      Output = General\EncodedModule()\Name
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s FormatCryptedFileModule(Flag.b = 0)
    
    If Flag = 0 
      Output.s = General\CryptedModule()\Name + "::" + General\CryptedModule()\Prefix
    Else
      Output = General\CryptedModule()\Name
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
EndModule  

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = --wRAIAAAA5PAAAAAQAw
; EnableXP
; DisableDebugger
; CompileSourceDirectory
; EnableUnicode